//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation

public class Offer: OfferRights {

    public enum Availability: String, Codable {
        case available = "Available"
        case comingSoon = "ComingSoon"

        public static let cases: [Availability] = [
          .available,
          .comingSoon,
        ]
    }

    public var price: Float

    public var availability: Availability

    public var endDate: Date?

    public var name: String?

    public var startDate: Date?

    /** The code of the subscription this offer is offered under, if any. */
    public var subscriptionCode: String?

    public init(deliveryType: DeliveryType, scopes: [String], resolution: Resolution, ownership: Ownership, price: Float, availability: Availability, exclusionRules: [ExclusionRule]? = nil, maxDownloads: Int? = nil, maxPlays: Int? = nil, playPeriod: Int? = nil, rentalPeriod: Int? = nil, endDate: Date? = nil, name: String? = nil, startDate: Date? = nil, subscriptionCode: String? = nil) {
        self.price = price
        self.availability = availability
        self.endDate = endDate
        self.name = name
        self.startDate = startDate
        self.subscriptionCode = subscriptionCode
        super.init(deliveryType: deliveryType, scopes: scopes, resolution: resolution, ownership: ownership, exclusionRules: exclusionRules, maxDownloads: maxDownloads, maxPlays: maxPlays, playPeriod: playPeriod, rentalPeriod: rentalPeriod)
    }

    private enum CodingKeys: String, CodingKey {
        case price
        case availability
        case endDate
        case name
        case startDate
        case subscriptionCode
    }

    public required init(from decoder: Decoder) throws {
        let container = try decoder.container(keyedBy: CodingKeys.self)

        price = try container.decode(.price)
        availability = try container.decode(.availability)
        endDate = try container.decodeIfPresent(.endDate)
        name = try container.decodeIfPresent(.name)
        startDate = try container.decodeIfPresent(.startDate)
        subscriptionCode = try container.decodeIfPresent(.subscriptionCode)
        try super.init(from: decoder)
    }

    public override func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)

        try container.encode(price, forKey: .price)
        try container.encode(availability, forKey: .availability)
        try container.encode(endDate, forKey: .endDate)
        try container.encode(name, forKey: .name)
        try container.encode(startDate, forKey: .startDate)
        try container.encode(subscriptionCode, forKey: .subscriptionCode)
        try super.encode(to: encoder)
    }

    override public func isEqual(to object: Any?) -> Bool {
      guard let object = object as? Offer else { return false }
      guard self.price == object.price else { return false }
      guard self.availability == object.availability else { return false }
      guard self.endDate == object.endDate else { return false }
      guard self.name == object.name else { return false }
      guard self.startDate == object.startDate else { return false }
      guard self.subscriptionCode == object.subscriptionCode else { return false }
      return super.isEqual(to: object)
    }
}
